* SBasic-Funktion BASICV fr QL-Today von .hpr'96
* Copyright (C) 1996 H.-Peter Recktenwald, Berlin

doctext MACRO ; +++ english text below +++

BASICV liest Variablenwerte aus jedem Job, der Basic-Struktur aufweist.
Das sind alle QLiberator-Programme, sofern sie mit der "names"-Option
compiliert wurden, die Minerva- und SMSQ/E-Basic-Jobs, und natrlich
das immer vorhandene Stamm-Basic (Job 0) des QL.

Die unten im Assemblertext angemerkten Einsprungpunkte erlauben unter den
dort notierten Voraussetzungen den Gebrauch auch aus beliebigen andersartigen
Programmen. Verbindungen nach "C" oder zu anderen Programmierhilfen sind bei
entsprechender Sachkenntnis ebensoleicht einzurichten.

Damit wird eine Mglichkeit geschaffen, die den vielzitierten "Environment
Variablen" entspricht, dabei aber durch Nutzung der Speicherverwaltung und
anderer Teile von SuperBASIC und Betriebssystem des QL je nach Anwendung in
weit vielseitigerer Form mit gleichzeitig entschieden geringerem Aufwand.
Die Verwendung wird insofern erleichtert, als hier keine neuen Regeln im
Umgang mit den Daten beachtet werden mssen, da sich alles in das vom QL
her Gewohnte fgt. Die Variablen selbst unterscheiden sich in nichts von
den Variablen der Basic-Interpreter. BASICV erweitert das System einzig
dahin, da diese aus jedem Programm o.a. Art gelesen werden knnen.

So lassen sich z.B. mit Hilfe gewhnlicher Variablendeklarationen im stets
vorhandenen Stamm-Basic des QL Datenlisten anlegen und auch programmiert
z.B. als Resultat irgendwelcher Berechnungen zusammenstellen, die dann auf
einfachste Weise von anderen Programmen gelesen werden und deren Ablauf
beeinflussen knnen. Solche Datenlisten mssen, wenn sie nicht direkt
eingegeben wurden, wenigstens einmal vom Programm durchlaufen worden sein,
bevor sie erkannt werden knnen.

Eine interessante Anwendung besteht in der Kontrolle QLiberator-compilierter
Programme, wo whrend ihres Ablaufs deren Variable aus einem Basic(-Job)
mitgelesen werden knnen. Besonders bei der Fehlersuche eine wertvolle Hilfe,
aber auch zum Aufbau situationsabhngig arbeitender Programme gut brauchbar.

Im Gebrauch hat sich diese Variante der Datengewinnung beim Autor im Verlauf
mehrerer Jahre als zuverlssig und vllig problemlos erwiesen. Die Funktion
wurde mit Gold-/Trump-Card-erweiterten JM-, JS-, MGG und Minerva-Systemen
sowie mit dem SMSQ/E(2.75) im GC-QL und im QXL-System erfolgreich geprft.
Fehler sind nur zu erwarten, wenn das eingesetzte Betriebsystem nicht mit
den dokumentierten Gegebenheiten von QDOS oder SuperBASIC bereinstimmt; das
der Ordnung halber erwhnt, dem Autor ist kein solches System im QL bekannt.

Einzig mag es in sehr seltenen Fllen vorkommen, da ein Lesevorgang gerade
in eine Variablenvernderung fllt, die im betr. Basic-Job vollzogen wird,
und darum der gelesene Wert nicht den wirklichen Verhltnissen entspricht.
Dies lt sich nicht abfangen, da die Basic-Jobs zugunsten des Multitasking
des Gesamtsystems in solchen Momenten nicht verriegelt werden. Immerhin aber
ist das Lesen durch BASICV soweit gesichert, da, wurde es einmal eingeleitet,
bis zu seinem Ende keine Vernderungen mglich sind. Das untersuchte Programm
wird whrend dieser Zeit (durch Prioritt 0) ruhiggestellt.

In der hier vorgelegten Form lassen sich Werte von Variablen "fremder" Jobs
nicht ndern. Auch dies lt sich bei entsprechender Kenntnis nachtragen.
Vornehmlich aus Sicherheitsgrnden, weil fr zuverlssige Funktion einiger
Aufwand ntig ist, wurde fr diese Verffentlichung darauf verzichtet.

Besser, wenn auch nicht mit denselben Steuermglichkeiten verbunden, wird
es sein, andere Programme z.B. durch Eingabe von "auen" zu beeinflussen.
Das ist berall dort problemlos mglich, wo ein Tastaturkanal existiert,
also etwa ein Fenster mit CON_... aufgemacht wurde, welches mit INPUT Daten
aufnimmt. Eine entsprechende Erweiterung, die auch mit PIPE und SER-Kanlen
verwendbar ist, wird Gegenstand des nchsten "Toolkit"-Teils in QL-Today sein.

Die Codedatei wird zu beliebigem Zeitpunkt mit RESPR(780), LBYTES und CALL
rsp. mit LRESPR geladen und aktiviert.

Der sofort einsetzbare Erweiterungs-Code steht auch in der Mailbox von
J.Merz zur Verfgung.
Die dort erhltliche Datei ist in unvernderter und nicht dokumentierter Form
zur beliebigen Verwendung bei nur kostenloser Weitergabe freigegeben. Fremde
Herkunftsvermerke sind zu unterlassen.


Aufruf:

        value  = BASICV ( [ job, ] name$ )

Parameter:

        Die Funktion verarbeitet ein oder zwei Parameter, berzhlige
        Posten werden ohne Fehlermeldung verworfen.

<job>   ist ein optionaler Parameter, mit dem die Datenquelle
        bestimmt werden kann:

        Ohne Angabe     Stamm-Basic, der Job 0

        -1              der aufrufende Job selber
        Leerstring      dasselbe

        JOB-NUMMER      im Bereich 0 bis 32767 (systembedingt kommem
                        aber nur Zahlen bis 119 vor) wird als einfache
                        Jobnummer bewertet, so, wie sie etwa bei den
                        QLiberator-Erweiterungen blich ist.
        QDOS-ID         als kombinierte Zahl aus der Job-Nummer und
                        einer vom System vergebenen Kontrollzahl
                        spezifiziert einen Job in der vom TK2 her
                        gewohnten Weise.

        JOB-NAME        (nur!) als String zu bergeben ist der Name
                        des zu untersuchenden Jobs. Gibt es mehrere
                        Jobs gleichen Namens, so gilt der mit der
                        hchsten Job-Nummer. Zustzliche Einflunahme
                        ist hier nicht mglich.

<name$> ist als String zu bergeben, der den Namen der Variablen enthlt,
        deren Wert gelesen werden soll.
        Alle nichtdimensionierten Variablentypen werden ausgewertet, auch
        die Schleifenvariablen von REPeat- oder FOR-Strukturen.
        Bei dimensionierten Variablen geht der erste Posten zurck, was vor
        allem dem Lesen einfach dimensionierter Strings dienen soll. Lesen
        ist immer unschdlich, darum wurde keine Beschrnkung vorgesehen.

Funktionsrckgabe:

<value> wird in demselben Typen zurckgegeben, wie ihn die Variable im
        gelesenen Job hat, und hat identischen Inhalt.
        Ein Vorteil der hier angegebenen Definition ist, da ganz in der
        gewohnten Weise das System des QL fr die Typen-Anpassung sorgt,
        der zu lesende Typ also nur in Sonderfllen einen Fehler erzeugen
        kann. Notfalls holt man die Werte in einen String, da der fr
        jede Variablenart geeignet ist, und prft sie dann im Programm.

        Fehlercodes im aufrufenden Job sind Zahlen vom Integer-Typ:
-2      (err.nj) kommt zurck, wenn der angegebene Job ungeeignet ist.
-12     (err.bn) signalisiert, da ein Jobname nicht existiert.
-15     (err.bp) wird u.a. bei parameterlosem Aufruf zurckgegeben.
ernum   kann auerdem alles sein, was beim Lesen von Basicparametern
        mglich ist, vornehmlich err.bp (-15) bei falschen Aufrufen.

        Fehlercodes bei formal korrekten Parametern:
""      Leerstring bei String-Variablen,
-1E601  bei Fliekomma-Variablen,
32768   bei Integer-Variablen (der Art name%)
        wenn der Name im Zieljob nicht existiert, er nicht zu einer Variablen
        gehrt, oder eine solche noch nicht mit einem Wert besetzt wurde.


Code der Basic-Erweiterung:

Wer keinen Assembler besitzt, oder den zum QUANTA-GST-Assembler passenden
Text nicht verarbeiten kann, mag sich mit folgender Procedur behelfen,
die ohne Parameter nur durch Eingabe von DAFI <enter> aufgerufen wird.

Die anschlieenden DATA-Zeilen beginnen mit dem vollen Namen der zu
erzeugenden Code-Datei, einem Krzel fr den hier benutzten Datentypen
und der Anzahl Bytes, aus der der Code besteht. Die Zeilen enthalten je
16 sedezimal codierte Bytes in einem Block als String und enden mit einer
einfachen durch byteweise Addition je Zeile ermittelten Prfsumme.
Den Schlu markiert ein "#", gefolgt von einer gleichartigen Prfsumme
ber den ganzen Datenblock.
Alternativ kann die Procedur DAFI byteweise angeordnete dezimale Daten
verarbeiten, Krzel dafr ist jeder Text =/= "hex"; dies mag in einer
spteren Ausgabe benutzt werden, ist fr den Augenblick aber belanglos.


doc MACRO

BASICV is a SuperBasic extension which, very similar to the "environment
variables" of other systems, enables reading of other SBasic-structured
jobs variable values. Those are the QLiberator compiled jobs if they have
been compiled with the "names" option active, the multitasking SBasic-jobs
of MINERVA and SMSQ, and the main SBasic of the QL which is always present.

In contrary to those "environment variables" BASICV does not introduce
another type of variables, it just makes the well known ones accessible
to any other job, read only, for safety. Thus the user doesn't need to
accomodate to jet another convention; these variables are to be handled
as usual for the SBasic ones, with no difference at all.

Additionally BASICV can be very valuable to debugging a compiled program or
any secondary SBasic program while running by monitoring its variables from
within another SBasic(-job).

This way of data acquisition proved very safe, and was tested with the QL
systems of JM, JS, MGG, MINERVA(1.93) and in the QXL with SMSQ/E(2.75).
At very rare occasions a reading operation might coincide with the variable
concerned just being changed by the owner program, which could result in
erroneous return values, despite that job will be halted while reading is
in progress.


The code can be loaded as usual and at any time with RESPR(780), LBYTES and
CALL or with LRESPR. It may freely be used for any non-commercial purpose.


The function:

        value  = BASICV ( [ job, ] name$ )

Parameter:

        One or two parameters, any more will be discarded with no action.

<job>   optional source of data:

        none            primary *Basic, job 0

        -1              calling job
        empty string    ditto

        JOB-NUMBER      as used with the Qlib extensions or,
        QDOS-ID         full length job specifier, as used with the TK2 calls.

        JOB-NAME        the job name can be passed in a string (only!).


<name$> a string with the name of the variable to read.
        Dimensioned variables will always return their 1st element.


Return values:

<value> will return with the same type as in the source job.

        Parameters related error messages (integers):
-2      (err.nj) job not suitable.
-12     (err.bn) job name doesn't exist.
-15     (err.bp) parameter(s) missing.
ernum   any other QDOS error


        Errors when parameters formally correct:
""      empty string: string variable not existing or not (yet) defined.
-1E601  floating point vari, ditto.
32768   Integer varia (name%) range overflow, or as above.


*Basic DATA loader:

1680 :
1690 DEFine PROCedure DAFI
1700 h$='123456789abcdef'
1710 RESTORE 1710:READ f$,e$,f
1720 DELETE f$:OPEN_NEW#4,f$
1730 c=0:n=0:m=0:l%=0:h=e$=='hex'
1740 REPeat l
1750  c%=0:l%=l%+1
1760  IF INKEY$=CHR$(27):EXIT l
1770  SELect h
1780   =1:READ e$:IF e$='#':EXIT l
1790    FOR g=1TO LEN(e$)STEP 2
1800     e%=16*(e$(g)INSTR h$)+e$(g+1)INSTR h$
1802     c%=c%+e%:n=n+1:IF e%:m=n
1804     PRINT#4,CHR$(e%);
1806    END FOR g
1810   =0
1820    FOR g=1 TO 8
1830     READ e$:IF e$='#':EXIT l
1840     e%=e$
1860     c%=c%+e%:n=n+1:IF e%:m=n
1870     PRINT#4,CHR$(e%);
1880    END FOR g
1884  END SELect
1890  c=c+c%:READ r
1900  IF r<>c%:PRINT'error in line '!l%;':'!c%!'=>'!r
1910 END REPeat l
1920 READ r
1930 CLOSE#4
1940 PRINT'checksum'!c,l%!'lines'
1950 PRINT f$,n!'bytes.'
1960 IF f<m OR f>n:PRINT'length error; should be'!f!'bytes.'
1970 IF c<>r:PRINT'global checksum error; should be'!r;'.'
1980 END DEFine
1990 :
10000 :
10010 DATA 'ram1_basicv_byt','hex',856
10020 DATA '43FA000C347801104E9270004E750000',1049
10030 DATA '00000001002A06424153494356000000', 489
10040 DATA '70F4D1EE005C2D480058226E00585589',1554
10050 DATA '2D4900583380E800700078034E75727E',1287
10060 DATA '3278011A4E9170004E4128482A017E00', 956
10070 DATA '70F145EB0008BBCA65E2672A61000152',1706
10080 DATA '6B182E369800534167066100017E670A', 977
10090 DATA '4A876A022E05610001D8D1EE005C2D48',1338
10100 DATA '005828006BA4244D6100013666943431',1015
10110 DATA 'E8006F8C2C092A487002220724074E41', 991
10120 DATA '204D28006600FF7CBA8767102F073F03',1190
10130 DATA '487A00F4700B220774004E412246204D',1074
10140 DATA '40C04E403F00487A00D8610001C0D1EE',1608
10150 DATA '005C43E8FFFA2D4900587603C6057200',1540
10160 DATA '4A806B482646DC8420462C046B3EE21E',1416
10170 DATA '6B3AD1EB00280C45030165082050D1EB',1399
10180 DATA '0028D1CB32105305673A5305670C5305',1058
10190 DATA '661A58892D4900586008242800022382', 906
10200 DATA 'E8023381E800280370004E75530567E2',1413
10210 DATA '323C8000550567DA323C0FCD243CA6CF',1448
10220 DATA 'C18260DA58892D4900583381E800674A',1657
10230 DATA '46EF00045281020100FE2E013278011A',1025
10240 DATA '4E91226E005893C72D4900584E40266D',1296
10250 DATA '0058206B0028D1C40C45030065082073',1012
10260 DATA '8800D1EB0028D1CB30183380E8005340',1662
10270 DATA '1398E802528951C8FFF8780170004E75',1836
10280 DATA '4E4046DF4E75700B341F221F4E414E75',1239
10290 DATA '327801187201780FC836B80153046606',1079
10300 DATA '3278011672007800B5CB631C262E0058',1110
10310 DATA '96AE005C48E750042A4A4E91264D4CDF',1556
10320 DATA '21022800660253434E7576DF7E007000',1103
10330 DATA '246C0068322C00623801E54C45F24004',1181
10340 DATA '3431E8006B4267442C0B28226B262644',1057
10350 DATA 'E21C6520D6FC0070B45B6618226E0058',1594
10360 DATA '3802534452891031E8011E1BBF00C003',1169
10370 DATA '56CCFFF257C9FFD42646660C24522E2A',1970
10380 DATA '00103E0170014E7570F47EFF46874E75',1524
10390 DATA '70FEBE6C0062621A72003207B2876610',1488
10400 DATA '246C0068E54F247270002E2A00103E01', 985
10410 DATA '70004E757A0172003231E80074DBD289',1557
10420 DATA 'D4361801640456C556054E75613666E4',1445
10430 DATA '70F43A3CFF0FCA7268FC672412056720',1713
10440 DATA '283268006A0C468467164684E20C6510',1196
10450 DATA 'D8045901650855016506550164027000', 912
10460 DATA '4A804E7548E7795E2A4F40C04E403F00',1497
10470 DATA 'D3CE246C0068E54F247270002C6A0058',1473
10480 DATA '300EE218655C2B4A002030196F54246E',1068
10490 DATA '00182C2E001CE20E6548DC069C8A6F42',1252
10500 DATA '45F26802E64ED5CE280A6B36E21C6532',1760
10510 DATA '2A4EDBEE0020280D6B28E21C652478DF',1543
10520 DATA '518A284DD8D2B01C6612320053412649',1395
10530 DATA '141C161BB503C60456C9FFF657CEFFE2',2045
10540 DATA '670270F995CE548ACD8E40C11F410001',1744
10550 DATA '46DF4CDF7A9E4E75',1067
10560 DATA '#',71624
20000 :

Der Assemblertext:

 ENDM
        pagelen 20000
        data 0
        section bv

* SB-Function
go      lea     bastab(pc),a1
        move.w  $110,a2         bp.init
        jsr     (a2)            > link extension(s) to basic(-job)
        moveq   #0,d0           no error (might help with certain QL-roms)
        rts

bastab  dc.w 0,0,1              no procedures, one function
        dc.w basicv-*
        dc.b 6,'BASICV'
        ds.w 0                  safely adjust to even address
        dc.w 0

bsv_rbn moveq   #-12,d0         err.bn
bsv_rrt add.l   $5c(a6),a0
        move.l  a0,$58(a6)      clear parameterspace
bsv_xit move.l  $58(a6),a1
        subq.l  #2,a1
        move.l  a1,$58(a6)
        move.w  d0,0(a1,a6.l)   ernum
        moveq   #0,d0           ret ok
        moveq   #3,d4           type integer
bsv_rbp rts

* entry to SB-Funktion
BASICV  moveq   #126,d1
        move.w  $11a,a1         qdos vector bv.chrix
        jsr     (a1)            > prepare for safe space
        moveq   #0,d0
        trap    #1              mt_inf
        move.l  a0,a4           sysvari
        move.l  d1,d5           calling job id
        moveq   #0,d7           prepare for primary sbasic (job 0)
        moveq   #-15,d0         err.bp
        lea     8(a3),a2        1st parameter
        cmp.l   a2,a5
        bcs.s   bsv_rbp         ? err.bp if none
        beq.s   bsv_dfj         ? just the variable name
        bsr     fetchlv         > fetch job no.
        bmi.s   bsv_nst         ? default to job 0
        move.l  0(a6,a1.l),d7   might be the job-id
        subq.w  #1,d1           flag
        beq.s   bsv_tjb         ? job specified by a number
        bsr     bsvjob          > find job-id from name
        beq.s   bsv_nst         ? not a valid string
bsv_tjb tst.l   d7              -ve use current job  +ve ok
        bpl.s   bsv_chk         ? found
        move.l  d5,d7           try calling jobs variables
bsv_chk bsr     bsvckid         > job-id from qdos no.
bsv_nst add.l   $5c(a6),a0
        move.l  a0,$58(a6)      clear parameter stack
        move.l  d0,d4
        bmi.s   bsv_xit         ? ret ernum
bsv_dfj move.l  a5,a2           all (remaining) parameters
        bsr     fetchst         > vari name
        bne.s   bsv_rrt         ? parameter error
        move.w  0(a1,a6.l),d2
        ble.s   bsv_rbn         ? length error
        move.l  a1,d6           save string ptr
        move.l  a0,a5           old parameterspace
        moveq   #2,d0           mt.jinf
        move.l  d7,d1           job to test
        move.l  d7,d2           top job in chain
        trap    #1              check for valid id
        move.l  a5,a0
        move.l  d0,d4
        bne     bsv_rrt         ? dest. is not a valid job
        cmp.l   d7,d5
        beq.s   bsv_nsp         ? don't halt the calling job
        move.l  d7,-(sp)        the dest.jobs id
        move.w  d3,-(sp)        and priority
        pea     retpri(pc)      care for return to re-activating
        moveq   #11,d0          mt.prior
        move.l  d7,d1
        moveq   #0,d2           halt dest. job
        trap    #1
bsv_nsp move.l  d6,a1           string ptr back
        move.l  a5,a0           bv-memory
        move.w  sr,d0
        trap    #0              supervisor
        move.w  d0,-(sp)        store old processor state
        pea     retusr(pc)      care for return to standard mode
        bsr     idf_tst         > find variname, type in d5, jdt in a5
        add.l   $5c(a6),a0
        lea     -6(a0),a1       leave some space
        move.l  a1,$58(a6)      clear remaning parameter space
        moveq   #3,d3
        and.b   d5,d3           type to return
;;        moveq   #0,d1           prepare error/string return
;;korrektur 14.1.97;; d1:=0 hier entbehrlich ;;
        tst.l   d0
        bmi.s   bsv_err         ? name error
        move.l  d6,a3           a3:=dest.A6
        add.l   d4,d6           vari-ptr
        move.l  d6,a0           a0:=valueptr(a3)
        move.l  d4,d6
        bmi.s   bsv_err         ? -ve ptr undef'd
        ror.b   #1,d6
        bmi.s   bsv_err         ? odd ptr not valid
        add.l   40(a3),a0       vari-address
        cmp.w   #$301,d5        type
        bcs.s   bsv_ndm         ? not dim'd
        move.l  (a0),a0         disp into vari memory
        add.l   40(a3),a0       base disp
        add.l   a3,a0           address of 1st dim'd item
bsv_ndm move.w  (a0),d1         len/int/exp
        subq.b  #1,d5
        beq.s   bsv_stg         ? string
        subq.b  #1,d5
        beq.s   bsv_fp          ? f.p.-number
        subq.b  #1,d5
        bne.s   bsv_irr         ? not an integer
bsr_int addq.l  #4,a1
        move.l  a1,$58(a6)
        bra.s   bsv_int         - wert bergeben

bsv_fp  move.l  2(a0),d2        <return f.p. result
bsr_fp  move.l  d2,2(a1,a6.l)
bsv_int move.w  d1,0(a1,a6.l)   <return integer result
        move.l  d3,d4           integer or f.p.
        moveq   #0,d0           ok
        rts

* error return
bsv_err moveq   #0,d1   ;;korrektur 14.1.97;;
        subq.b  #1,d5
        beq.s   bsr_int         ? empty string
        move.w  #$8000,d1
        subq.b  #2,d5
        beq.s   bsr_int         ? -0 = 32768 integer
        move.w  #$0FCD,d1
        move.l  #$A6CFC182,d2   -1e601
        bra.s   bsr_fp          - f.p. error return

* d4:ptr to vari value  d5.b type-1
* a1:ri-stack  a0:ptr to vari(strg)  a3:job-A6  a5:dest.jdt
bsv_stg addq.l  #4,a1
        move.l  a1,$58(a6)      clear parameterstack, leave count.w
        move.w  d1,0(a1,a6.l)   length
        beq.s   ptu_ret         ? return empty string
* some qdos vectors mustn't be called while in superviser mode
        move.w  4(sp),sr        ..which applies to bv.chrix
        addq.l  #1,d1
        and.b   #-2,d1          even up
        move.l  d1,d7           adjusted string length
        move.w  $11a,a1         bv.chrix
        jsr     (a1)            >
        move.l  $58(a6),a1      bv.rip
        sub.l   d7,a1
        move.l  a1,$58(a6)      safe space for string return
        trap    #0              halt again
* re-fetch dest.job ptrs which might have been changed after bv.chrix
        move.l  88(a5),a3       dest.job-A6
        move.l  40(a3),a0       and variable space
        add.l   d4,a0           ptr to the string
        cmp.w   #$0300,d5
        bcs.s   bsv_nds         ? not a dim'd string
        move.l  0(a3,a0.l),a0   disp to dim'd values
        add.l   40(a3),a0       base ptr to values
bsv_nds add.l   a3,a0           address
        move.w  (a0)+,d0
        move.w  d0,0(a1,a6.l)   advance to chars and inst. count.w
        subq.w  #1,d0
bsv_put move.b  (a0)+,2(a1,a6.l)
        addq.l  #1,a1
        dbra    d0,bsv_put      ? fetch string data
ptu_ret moveq   #1,d4           vari.type string
        moveq   #0,d0           ok
        rts

* return procedure to resetting old processor state
retusr  trap    #0              supervisor to
        move.w  (sp)+,sr        restore old processor state
        rts
* return procedure to restoring old job priority
retpri  moveq   #11,d0          mt.prior
        move.w  (sp)+,d2        old priority
        move.l  (sp)+,d1        job
        trap    #1
        rts

* fetch (an unlimited number of) parameters from basic
* long integer(s):
fetchlv move.w  $118,a1         ca.gtlin
        moveq   #1,d1           flag: long integer
        moveq   #15,d4
        and.b   1(a6,a3.l),d4   type
        subq.b  #1,d4
        bne.s   ftv_num         ? maybe numeric
* string(s):
fetchst move.w  $116,a1         ca.gtstr
        moveq   #0,d1           flag: string
ftv_num moveq   #0,d4           prepare error return ok
        cmp.l   a3,a2
        bls.s   ftv_nix         ? ret 0 if no parameter passed
        move.l  $58(a6),d3      bv.rip
        sub.l   $5c(a6),d3      bv.ribas
        movem.l d1/d3/a5,-(sp)  flag, size of basic-stack, top of parm.table(s)
        move.l  a2,a5           upper bound for this call
        jsr     (a1)            > fetch value
        move.l  a5,a3           discard fetched parameter table(s)
        movem.l (sp)+,d1/a0/a5  d1:flag a0:ri.stack a5:parm.top
        move.l  d0,d4
        bne.s   ftv_nix         ? ret ernum
        subq.w  #1,d3           num. of parameters > 0 else ret 'mi'
ftv_nix rts

*
* assembler routines accessible from any job and at any processor state
*

* find the (top) job with the
* name passed as .w-counted string at (a1,a6)+, starting a1=($58(a6))
* ENTRY  0(a1,a6)+:count.w&string  a4:sysvari  a6:own ref.addr
* EXIT   'eq':job not found 'mi':use current job d7:job-id  d0-d4/d6/a1/a2:xx
bsvjob  moveq   #-33,d3         mask lower- to uppercase letters
        moveq   #0,d7           prepare error flag
        moveq   #0,d0           and "ok"-return
        move.l  104(a4),a2      sv.jbbas
        move.w  98(a4),d1       sv.jbmax count of jobs
        move.w  d1,d4
        lsl.w   #2,d4
        lea     4(a2,d4.w),a2   top of table of job definition tables
        move.w  0(a1,a6.l),d2   string count
        bmi.s   bsj_rbn         ? -ve too much, ret 'eq' and err.bn
        beq.s   bsj_xit         ? empty for current job, ret 'mi'
        move.l  a3,d6           save parameter ptr
bsj_jnm move.l  -(a2),d4        check jobs top down
        bmi.s   bsj_nxj         ? not a job definition table
        move.l  d4,a3
        ror.b   #1,d4
        bcs.s   bsj_nxj         ? bad address
        add.w   #104+8,a3       advance to job name
        cmp.w   (a3)+,d2
        bne.s   bsj_nxj         ? other len
        move.l  $58(a6),a1      string
        move.w  d2,d4
        subq.w  #1,d4           count
bsj_cmp addq.l  #1,a1
        move.b  1(a1,a6.l),d0   string
        move.b  (a3)+,d7        job name
        eor.b   d7,d0
        and.b   d3,d0
        dbne    d4,bsj_cmp      name
bsj_nxj dbeq    d1,bsj_jnm      count qdos jobs
        move.l  d6,a3           parameter ptr back
        bne.s   bsj_rbn         ? name not found, err.bn
        move.l  (a2),a2
        move.l  16(a2),d7       hi.w tag-no.
        move.w  d1,d7           lo.w job-no.
        moveq   #1,d0           flag ok
        rts
bsj_rbn moveq   #-12,d0         err.bn
        moveq   #-1,d7          'eq' on error
bsj_xit not.l   d7              'mi' for current job
        rts

* check d7 for a valid job-id or find id of job number
* ENTRY d7 id/qdos-no.  a4 sysvari
* EXIT  d0 ernum  d1 q.no. d7 job-id  a2 jdt
bsvckid moveq   #-2,d0          prepare err.nj
        cmp.w   98(a4),d7       sv.jbmax
        bhi.s   bsc_ret         ? job doesn't exist
        moveq   #0,d1
        move.w  d7,d1
        cmp.l   d7,d1
        bne.s   bsc_tid         ? id fully specified
        move.l  104(a4),a2
        lsl.w   #2,d7
        move.l  0(a2,d7.w),a2   jdt
        move.l  16(a2),d7
        move.w  d1,d7
bsc_tid moveq   #0,d0
bsc_ret rts

*
* this routine can be used by any program to find a basic variable ptr
*

idf_ndf moveq   #1,d5           parameter type string
        moveq   #0,d1
        move.w  0(a1,a6.l),d1   len
        moveq   #-'%',d2        "%"=37 "$"=36
        add.l   a1,d1           last char
        add.b   1(a6,d1.l),d2   -ve "$" 0 "%" +ve f.p.
        bcc.s   idf_nst         ? undef'd string
        sne     d5
        addq.b  #3,d5           set to 0002 f.p 0003 integer
idf_nst rts

* ENTRY  d7 ownerjob-id of .w-counted variname at 0(a1,a6.l)+  a4 sysvari
* EXIT   d0:ernum  d1/d2/d3:xx  d4:address
*        d5.w:use|type  d6:sourcejob-A6 a2:xx a5: dest. j.d.t.
idf_tst bsr.s   era_fnm         >
        bne.s   idf_ndf         ? name not present, ret err.nf
        moveq   #-12,d0         prepare err.bn
        move.w  #$ff0f,d5
        and.w   -4(a2,d6.l),d5
        beq.s   idf_nix         ? usage not defined
        move.b  d5,d1
        beq.s   idf_nix         ? dim'd or string slice
        move.l  0(a2,d6.l),d4
        bpl.s   idf_adr         ? an address
        not.l   d4
        beq.s   idf_nix         ? till unknown
        not.l   d4
        lsr.b   #1,d4
        bcs.s   idf_nix         ? odd ptr
        add.b   d4,d4           restore ptr
idf_adr subq.b  #4,d1
        bcs.s   idf_var         ? 1/2/3 value
        subq.b  #2,d1
        bcs.s   idf_nix         ? 4/5 sbasic defn
        subq.b  #2,d1
        bcc.s   idf_nix         ? 8/9 not a loop index
idf_var moveq   #0,d0
idf_nix tst.l   d0
        rts

*
* this routine can be used by any program to find a basic name table
*

* find the .w-counted name at (a1,a6)+ owned by job with id in d7
* ENTRY a1(a6) string  a4 sysvari
* EXIT  d0 ernum  d6 dest.job-A6  -4(a2,d6) name list in dest.job  a5:jdt
m setstr d1/d2/d3/d4/d7/a1/a3/a4/a5/a6
a setstr a5
p setnum [.instr(m,a)]/3*4 ; this way {p} safely points to stacked reg A5
era_fnm movem.l [m],-(sp)
        move.l  sp,a5           save current (user or supervisor) stack
        move.w  sr,d0
        trap    #0
        move.w  d0,-(sp)
        add.l   a6,a1           string address
        move.l  104(a4),a2      sv.jbbas
        lsl.w   #2,d7
        move.l  0(a2,d7.w),a2   job definition table
        move.l  88(a2),a6       jobA6
        move.w  a6,d0
        ror.b   #1,d0           odd A6
        bcs.s   enm_nfd         ? certainly not a basic-job
* excessive odd-ness and sign testing done for safety if dest.job is not a
* basic-job, as there is no trivial means to checking for this kind of jobs.
        move.l  a2,[p](a5)      store jdt to return with A5
era_ojb move.w  (a1)+,d0        len
        ble.s   enm_nfd         ? empty or too long
        move.l  24(a6),a2       bv.nbas name table
        move.l  28(a6),d6       bv.nt
        lsr.b   #1,d6
        bcs.s   enm_nfd         ? odd
        add.b   d6,d6           restore ptr
        sub.l   a2,d6
        ble.s   enm_nfd         ? none or too many
        lea     2(a2,d6.l),a2   variables searching top down for speed
        lsr.w   #3,d6           count of sbasic names
        add.l   a6,a2           top of name table
        move.l  a2,d4
        bmi.s   enm_nfd         ? -ve
        ror.b   #1,d4
        bcs.s   enm_nfd         ? odd
        move.l  a6,a5
        add.l   32(a6),a5       address of name list
        move.l  a5,d4
        bmi.s   enm_nfd         ? -ve
        ror.b   #1,d4
        bcs.s   enm_nfd         ? odd
        moveq   #-33,d4         mask to uppercase letters
enm_nxn subq.l  #8,a2           ptr to names ptr
        move.l  a5,a4
        add.w   (a2),a4
enm_nam cmp.b   (a4)+,d0
        bne.s   enm_ntb         ? other length
        move.w  d0,d1
        subq.w  #1,d1           length count
        move.l  a1,a3
enm_chr move.b  (a4)+,d2        name
        move.b  (a3)+,d3        string
        eor.b   d2,d3
        and.b   d4,d3
enm_eqc dbne    d1,enm_chr      ? next char
enm_ntb dbeq    d6,enm_nxn      ? more names
        beq.s   enm_oke         ? found
enm_nfd moveq   #-7,d0          err.nf
enm_oke sub.l   a6,a2
        addq.l  #2,a2
        exg     a6,d6
        move.w  sr,d1
        move.b  d1,1(sp)
        move.w  (sp)+,sr
        movem.l (sp)+,[m]
        rts

    end  .hpr'96  eof 
